package com.sun.jndi.ldap;

import javax.naming.directory.DirContext;
import javax.naming.directory.Attribute;
import javax.naming.CompositeName;
import javax.naming.ldap.Control;
import java.util.Vector;
import javax.naming.directory.Attributes;
import javax.naming.NamingException;
import com.sun.jndi.toolkit.ctx.Continuation;
import javax.naming.Name;
import javax.naming.NameClassPair;

final class LdapNamingEnumeration extends AbstractLdapNamingEnumeration<NameClassPair>
{
    private static final String defaultClassName;
    
    LdapNamingEnumeration(LdapCtx ldapCtx, LdapResult ldapResult, Name name, Continuation continuation) throws NamingException {
        super(ldapCtx, ldapResult, name, continuation);
    }
    
    @Override
    protected NameClassPair createItem(String nameInNamespace, Attributes attributes, Vector<Control> vector) throws NamingException {
        Attribute value;
        String defaultClassName;
        if ((value = attributes.get(Obj.JAVA_ATTRIBUTES[2])) != null) {
            defaultClassName = (String)value.get();
        }
        else {
            defaultClassName = LdapNamingEnumeration.defaultClassName;
        }
        CompositeName o = new CompositeName();
        o.add(this.getAtom(nameInNamespace));
        Object o2;
        if (vector != null) {
            o2 = new NameClassPairWithControls(o.toString(), defaultClassName, this.homeCtx.convertControls(vector));
        }
        else {
            o2 = new NameClassPair(o.toString(), defaultClassName);
        }
        o2.setNameInNamespace(nameInNamespace);
        return o2;
    }
    
    @Override
    protected AbstractLdapNamingEnumeration<? extends NameClassPair> getReferredResults(LdapReferralContext ldapReferralContext) throws NamingException {
        return (AbstractLdapNamingEnumeration)ldapReferralContext.list(this.listArg);
    }
    
    static {
        defaultClassName = DirContext.class.getName();
    }
}
